| Face Engine SDK 5.35.0 A face detection, recognition and tracking engine.

Public Types | Public Member Functions | Protected Attributes | List of all members
fsdk::ResultValue< R, V, typename std::enable_if< std::is_copy_constructible< V >::value==false >::type > Struct Template Reference

Addon for Result to output some value aside the result. Specialization for non copiable types. More...

`#include <ResultValue.h>`

Inheritance diagram for fsdk::ResultValue< R, V, typename std::enable_if< std::is_copy_constructible< V >::value==false >::type >:

## Public Types
typedef R | EnumType
| Result enumeration type.
typedef V | ValueType
| Result value type.
Public Types inherited from fsdk::Result< R >
using | ErrorType = R
| Result value enumeration type.
using | Traits = ErrorTraits< R >

## Public Member Functions
| ResultValue (R result) noexcept
| Initializes result. More...
| ResultValue (R result, V &&value) noexcept
| Initializes result. More...
const V & | getValue () const noexcept
| Gets result value. More...
V && | takeValue () noexcept
| Gets result value as rvalue. More...
const V * | operator-> () const noexcept
| Gets result value. More...
Public Member Functions inherited from fsdk::Result< R >
| Result (R error) noexcept
| Initializes result. More...
| Result () noexcept
| Initializes result by default.
R | getError () const noexcept
| Gets actual result value. More...
bool | isError () const noexcept
| Checks for an error. More...
bool | isOk () const noexcept
| Checks for a success. More...
| operator bool () const noexcept
| Checks for a success. More...
| operator int () const noexcept=delete
| Values of type bool participate in integral promotions. A prvalue of type bool can be converted to a prvalue of type int, with false becoming zero and true becoming one. This overload prevents the bool() operator above from participating in dangerous implicit conversion chains such as bool->int, bool->int->float, bool->int->double.
const char * | what () const noexcept
| Gets a textual description of the result. More...

## Protected Attributes
V | m_value
| Actual value.

## Detailed Description

### template<typename R, typename V>
struct fsdk::ResultValue< R, V, typename std::enable_if< std::is_copy_constructible< V >::value==false >::type >

Addon for Result to output some value aside the result. Specialization for non copiable types.

Template Parameters

  R | result enumeration type.
  V | result value type.

Note
  All rules for Result template parameter aplly to R.
  V instance is always held by value despite -> operators.

## Constructor & Destructor Documentation

## ◆ ResultValue() [1/2]

template<typename R , typename V >

fsdk::ResultValue< R, V, typename std::enable_if< std::is_copy_constructible< V >::value==false >::type >::ResultValue | ( | R | result | ) |
| inlinenoexcept

Initializes result.

Parameters

  [in] | result | value to set.

## ◆ ResultValue() [2/2]

template<typename R , typename V >

fsdk::ResultValue< R, V, typename std::enable_if< std::is_copy_constructible< V >::value==false >::type >::ResultValue | ( | R | result,
|  | V && | value
| ) |  |
| inlinenoexcept

Initializes result.

Parameters

  [in] | result | result to set.
  [in] | value | value to set.

## Member Function Documentation

## ◆ getValue()

template<typename R , typename V >

const V& fsdk::ResultValue< R, V, typename std::enable_if< std::is_copy_constructible< V >::value==false >::type >::getValue | ( |  | ) | const
| inlinenoexcept

Gets result value.

Note
  Result validated in runtime.

Returns
  Value.

## ◆ operator->()

template<typename R , typename V >

const V* fsdk::ResultValue< R, V, typename std::enable_if< std::is_copy_constructible< V >::value==false >::type >::operator-> | ( |  | ) | const
| inlinenoexcept

Gets result value.

Note
  Result validated in runtime.

Returns
  Value.

## ◆ takeValue()

template<typename R , typename V >

V&& fsdk::ResultValue< R, V, typename std::enable_if< std::is_copy_constructible< V >::value==false >::type >::takeValue | ( |  | ) |
| inlinenoexcept

Gets result value as rvalue.

Note
  Result validated in runtime.
  Don't call more than once

Returns
  Value.

The documentation for this struct was generated from the following file:

- include/fsdk/Types/ResultValue.h